﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl<dynamic>" %>
<script type="text/javascript">
    var _lastCompSelected = "";

    function Comp_OnChange() {
        var comp = document.getElementById("componentList");
        var text = comp.options[comp.selectedIndex].text;
        var val = comp.options[comp.selectedIndex].value;
        
        Comp_HideLast();

        _lastCompSelected = val;
        $("#" + _lastCompSelected).show();
    }


    function Comp_HideLast() {
        if (_lastCompSelected != "") {
            $("#" + _lastCompSelected).hide();
        }
    }
</script>

<div id="comp_container">

<div id="components">


    <div id="comp_Aggregate" class="comp" style="display:none" >
    <div class="comp_name">Aggregate</div>
    <div class="comp_desc">Provides sum, min, max, avg, count aggregate functions for lists.</div>
    <pre class="brush: js">
    // Aggregate plugin allows sum, min, max, avg, count aggregate functions to 
    // be applied to lists of objects.

    set numbers = [1, 2, 3, 4, 5, 6, 7, 8, 9];

    // Example 1: Using format sum of expression
    set sum = sum of numbers;
    set avg = avg of numbers;
    set sum = min of numbers;
    set min = max of numbers;
    set count = count of numbers;

    // Example 2: Using format sum(expression)
    sum = sum( numbers );  
    </pre>
    </div>

    <div id="comp_Bool" class="comp" style="display:none" >
    <div class="comp_name">Bool</div>
    <div class="comp_desc">Provides synonyms yes/no, on/off for bool values true/false.</div>
    <pre class="brush: js">
    // Bool plugin allows aliases for true/false

    set result1 = on;
    set result2 = off;
    set result3 = yes;
    set result4 = no;
    set result5 = true;
    set result6 = false;
    </pre>
    </div>

    <div id="comp_Compare" class="comp" style="display:none" >
    <div class="comp_name">Compare</div>
    <div class="comp_desc">Provides synonyms for comparison operators</div>
    <pre class="brush: js">
    
    // Compare plugin allows word aliases for the comparison operators. See list below
    // 
    // ALIAS:                FOR:
    // "less than",          "<" 
    // "before",             "<" 
    // "below",              "<" 
    // "is below",           "<" 
    // "is before",          "<"
    // "more than",          ">" 
    // "after",              ">" 
    // "above",              ">" 
    // "is after",           ">" 
    // "is above",           ">" 
    // "less than equal",    "<="
    // "less than equal to", "<="
    // "more than equal",    ">="
    // "more than equal to", ">="
    // "is",                 "=="
    // "is equal",           "=="
    // "is equal to",        "=="
    // "equals",             "=="
    // "equal to",           "=="
    // "not",                "!="
    // "not equal",          "!="
    // "not equal to",       "!="
    // "is not",             "!="
    // "is not equal to",    "!=" 
    set a = 2, b = 4;
    // Example 1: Using <
    if a less than b then print a less than b;
    if a before b    then print a before b;
    if a below  b    then print a below b;
    if a is before b then print a is before b;
    if a is below b  then print a is below b;

    // Example 2: Using <=
    if a less than equal b    then print a less than equal b 
    if a less than equal to b then print a less than equal to b

    // Example 2: Using >
    if a more than b then print a more than b
    if a after b     then print a after  b
    if a above b     then print a above b
    if a is after b  then print a is after b
    if a is above b  then print a is above b  
    </pre>
    </div>

    <div id="comp_Date" class="comp" style="display:none" >
    <div class="comp_name">Date</div>
    <div class="comp_desc">Provides word based representation for dates e.g December 21st 2011</div>
    <pre class="brush: js">
    // Date plugin allows date expressions in a friendly format like January 1 2012;
    // Following formats are supported.

    set date1 = January 1st 2012;
    set date2 = jan 10;
    set date3 = Jan 11 2012;
    set date4 = Jan 12, 2012;
    set date5 = Jan 13th;
    set date6 = Jan 14th 2012;
    set date7 = Jan 15th, 2012;
    set date8 = January 16;
    set date9 = January 17, 2012;
    set date10 = January 18th;
    set date11 = January 19th, 2012;
    set date12 = January 20th 2012 at 9:20 am; 

    if today is before June 25th 2012 then
        print we're in the first half of the year
    </pre>
    </div>

    <div id="comp_Day" class="comp" style="display:none" >
    <div class="comp_name">Day</div>
    <div class="comp_desc">Provides alias and word based representation for days e.g Tuesday, Saturday, today, tommorrow </div>
    <pre class="brush: js">
    // Day plugin allows days of the week to be used as words. 
    // lowercase and uppercase days are supported:
    // 1. Monday - Sunday
    // 2. monday - sunday

    set day = Monday;

    if tomorrow is Saturday then
        print Thank god it's Friday
    else 
        print More days to work
    </pre>
    </div>

    <div id="comp_Env" class="comp" style="display:none" >
    <div class="comp_name">Env</div>
    <div class="comp_desc">Provides access to environment variables</div>
    <pre class="brush: js">
    // Env plugin allows direct access to environment variables via the "env" object.

    // Example 1: Access to user variables only via the ".user" property of env.
    result = env.user.path;

    // Example 2: Access to system variables via the ".sys" property of env.
    result = env.sys.path;

    // Example 3: Access to environment variable without specifying sys or user.
    result = env.path;
    result = env.SystemRoot;
    </pre>
    </div>

    <div id="comp_Fluent" class="comp" style="display:none" >
    <div class="comp_name">Fluent</div>
    <div class="comp_desc">Provides ability to call methods in a fluent way with method before class name. e.g. activate user 'kreddy'</div>
    <pre class="brush: js">
 
     // Fluent plugin allows methods to be called in different ways instead of the 
     // typicall class.method( arg1> ,arg2 etc )

     // Supported ways of calling methods:
     // 1.  method  class .
     // 2.  method  class  arg1 arg2 .
     // 3.  class   arg1   method .
     // 4.  method  class  arg1_name : arg1_value, arg2_name : arg2_value .
     // 5.  method  class  arg1, 
 
     // Examples
     activate user         
     delete file "c:\temp.txt".
     file "c:\temp.txt" exists.
     run program "msbuild.exe", solution: 'comlib.sln', mode: "debug", style: "rebuild all".
 
     // The above calls translate to:
     // 1. user.activate();
     // 2. File.Delete("c:\temp.txt");
     // 3. File.Exists("c:\temp.txt")
     // 4. Program.Run("msbuild.exe", solution: "comlib.sln', mode: "debug", style: "rebuild all");
    </pre>
    </div>

    <div id="comp_Holiday" class="comp" style="display:none" >
    <div class="comp_name">Holiday</div>
    <div class="comp_desc">Provides holiday names e.g. Christmas, Independence Day, Christmas Eve, New Years</div>
    <pre class="brush: js">
    // Holiday plugin allows references to dates using Holiday names such as:
    // Christmas
    // Independence day
    // Valentines day
    // New Years

    if today is after New Years 2012 then 
        print happy new year!
    </pre>
    </div>

    <div id="comp_Linq" class="comp" style="display:none" >
    <div class="comp_name">Linq</div>
    <div class="comp_desc">Provides partial support for linq-like queries on lists.</div>
    <pre class="brush: js">
    // Linq plugin is a Light-weight and partial version of Linq style queries and comprehensions
    // NOTE: This has limited functionality as of this release.
    set books = [ 
                    { name: 'book 1', pages: 200, author: 'homey' },
                    { name: 'book 2', pages: 120, author: 'kdog' },
                    { name: 'book 3', pages: 140, author: 'homeslice' }
                ];
 
    // Case 1: start with source books> and system auto creates variable book
    set favorites = books where book.pages < 150 and book.author == 'kdog';

    // Case 2: using from variable in source
    set favorities = from book in books where book.pages < 150 and book.author == 'kdog';
    set name = favorites[0].name;
    print favorite book name is : #{name}
    </pre>
    </div>

    <div id="comp_Marker" class="comp" style="display:none" >
    <div class="comp_name">Marker</div>
    <div class="comp_desc">Provides markers/comments that are checked for syntax</div>
    <pre class="brush: js">
    // Marker plugin allows you to mark code like comments but in the form of statements
    // so that syntax is checked. This allows for structured comments.

    // Case1 : Todo
    @todo: i need to add extra comments here

    // Case2 : Todo quoted
    @todo: "I need to add extra checks here and
    also do additional cleanup of code"

    // Case 3 : bug
    @bug: 'this bug related to parsing'
    @bug: this bug related to johns code!
    </pre>
    </div>

    <div id="comp_Money" class="comp" style="display:none" >
    <div class="comp_name">Money</div>
    <div class="comp_desc">Provides dollar sign $ support for numbers.</div>
    <pre class="brush: js">
    // Money plugin simply allows the $ to be prefixed to numbers.

    set salary = $225.50;
    if salary is more than $160 then
        print I worked overtime.
    else 
        print regular pay
    </pre>
    </div>

    <div id="comp_Print" class="comp" style="display:none" >
    <div class="comp_name">Print</div>
    <div class="comp_desc">Provides functionality to print to console a line of text without wrapping around quotes.</div>
    <pre class="brush: js">
    // Print plugin derives from the "TakeoverPlugin"
    // Takeovers are keywords that consume the entire line of text in the script
    // after the keyword. 
    // In this case of the Print plugin, it consume the rest of the line and you
    // don't need to wrap text around quotes.

    set language = 'fluentscript';
    print No need for quotes in #{language} if text to print is on one line    
    </pre>
    </div>

    <div id="comp_Round" class="comp" style="display:none" >
    <div class="comp_name">Round</div>
    <div class="comp_desc">Provides rounding of numbers using round, round up, round down.</div>
    <pre class="brush: js">
    // Round plugin provides functions to round, round up or round down numbers.

    set a = 2.3;

    // Rounds the number using standing round technique of .4
    set b = round 2.3;

    // Gets rounded up to 3
    set c = round up 2.3; 

    // Gets rounded down to 2
    set d = round down 2.3;
    </pre>
    </div>

    <div id="comp_Run" class="comp" style="display:none" >
    <div class="comp_name">Run</div>
    <div class="comp_desc">Provides alternative ways of calling a function.</div>
    <pre class="brush: js">
    // Run plugin provides alternate way to call a function for fluid syntax.
    // Notes: 
    // 1. The keyword "function" can be aliased with the word "step"
    // 2. The name of a function can be in quotes with spaces.

    // This is a function with 0 parameters so parentheses are not required
    step Cleanup
    {
        // do something here.
        print cleaning up
    }
 

    // This is a function with string for name and 0 parameters so parentheses are not required
    step 'Clean up apartment'
    {
        // do something here.
        print cleanup apartment
    }

    // Example 1: Call function normally
    Cleanup();

    // Example 2: Call function using Run keyword
    run Cleanup();

    // Example 3: Call function using run without parenthesis for function name.
    run Cleanup;

    // Example 4: Call function with spaces in name using run with quotes for function name.    
    run 'Clean up apartment';

    // Example 5: Call function with spaces using run and keyword.
    run step 'Clean up apartment';
    </pre>
    </div>

    <div id="comp_Sort" class="comp" style="display:none" >
    <div class="comp_name">Sort</div>
    <div class="comp_desc">Provides ability to sort of list of either basic types of objects with properties.</div>
    <pre class="brush: js">
    // Sort plugin allows you to sort a list

    // Case 1: sort list of basic types
    set numbers = [4, 3, 1, 7, 5, 2, 6];
    sort numbers asc;
    sort numbers desc;

    // Case 2: start with source books and system auto creates variable book
    set books = [ 
                    { name: 'book 1', pages: 200, author: 'homey' },
                    { name: 'book 2', pages: 120, author: 'kdog' },
                    { name: 'book 3', pages: 140, author: 'homeslice' }
                ];     
    sort books by book.pages asc;
    sort books by book.pages desc;
    sort i in books by i.pages desc;
 
    </pre>
    </div>

    <div id="comp_Swap" class="comp" style="display:none" >
    <div class="comp_name">Swap</div>
    <div class="comp_desc">Provides ability to swap values of 2 variables in 1 statement e.g swap a with b;</div>
    <pre class="brush: js">
    // Swap plugin provides 1 line statement to swap variables.

    set a = 1, b = 2;

    // Swap values in 1 statement.
    // Instead of needing a third variable.
    swap a with b;
    </pre>
    </div>

    <div id="comp_Time" class="comp" style="display:none" >
    <div class="comp_name">Time</div>
    <div class="comp_desc">Provides time representation in format 12:30 pm</div>
    <pre class="brush: js">
    // Time plugin provides a convenient way to represent time in fluent syntax.

    set time = 12:30 pm;

    if time is before 12:30 pm then
        print it's time to go to lunch!
    else 
        print good lunch
    </pre>
    </div>

    <div id="comp_Uri" class="comp" style="display:none" >
    <div class="comp_name">Uri</div>
    <div class="comp_desc">Provides url and folder representations as strings without quotes.</div>
    <pre class="brush: js">
    // Uri plugin allows you urls and file paths without surrounding them in 
    // quotes as long as there are no spaces. These are interpreted as strings.

    set url1 = www.yahoo.com;
    set url2 = http://www.google.com;
    set url3 = http://www.yahoo.com?user=kishore%20&id=123;
    set file1 = c:\users\kishore\settings.ini;
    set file2 = c:/data/blogposts.xml;

    // Since this file has a space in it... you have to surround in quotes.
    set file3 = 'c:/data/blog posts.xml';
    </pre>
    </div>

    </div>
</div>
<script type="text/javascript">
    SyntaxHighlighter.all()
</script>